/**
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.disy.legato.net.protocol.classpath;

import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;

import org.apache.commons.httpclient.ConnectTimeoutException;
import org.apache.commons.httpclient.params.HttpConnectionParams;
import org.apache.commons.httpclient.protocol.Protocol;
import org.apache.commons.httpclient.protocol.ProtocolSocketFactory;

public class ClassPathSocketFactory implements ProtocolSocketFactory {

  @Override
  public Socket createSocket(String host, int port) throws IOException, UnknownHostException {
    return createSocket(host, port, null, 0, null);
  }

  @Override
  public Socket createSocket(String host, int port, InetAddress address, int localPort)
      throws IOException,
      UnknownHostException {
    return createSocket(host, port, address, 0, null);
  }

  @Override
  public Socket createSocket(
      String host,
      int port,
      InetAddress address,
      int localPort,
      HttpConnectionParams params)
      throws IOException,
      UnknownHostException,
      ConnectTimeoutException {
    // TODO Auto-generated method stub
    return new ClassPathSocket();
  }

  public static void register() throws Exception {
    Protocol.registerProtocol("classpath", new Protocol(
        "classpath",
        new ClassPathSocketFactory(),
        10080));
  }
}
